import json
import logging
import threading
import urllib3
import os
import re
import sys
import random
import time
import boto3
from botocore.exceptions import ClientError



    
_rand = random.randint(10, 2400)
 

org_client = boto3.client('organizations')
s3client = boto3.client('s3')
iam_client = boto3.client('iam')
ssmclient = boto3.client('ssm')
sc_client = boto3.client('servicecatalog')

http = urllib3.PoolManager()
logger = logging.getLogger(__name__)
logger.setLevel(logging.DEBUG)
#==
def get_ssm_para(name):
    response = ssmclient.get_parameter(Name=name)
    return response['Parameter']['Value']
def put_ssm_para(kdict):
    pres = ssmclient.put_parameter(
        Name=kdict['Name'], Description=kdict['Description'], Value=kdict['Value'], Type=kdict['Type'], Overwrite=True)
def gen_surl(bucketname, keyname):
    url = s3client.generate_presigned_url(ClientMethod='get_object', Params={
                                          'Bucket': bucketname, 'Key': keyname})
    return url
def b_putpriv_v1(bucket, key,  acl):
    srep = s3client.put_object_acl(ACL=acl, Bucket=bucket, Key=key)
    return srep
def b_putpriv(bucket, key, body,type):
    srep = s3client.put_object(
        ACL='private', Body=body, Bucket=bucket, Key=key, ContentType=type,)
    print(srep)
    return srep
def b_get_obj(bucket, bkey):
    object = s3client.get_object(Bucket=bucket, Key=bkey)
    return(object['Body'].read().decode('utf-8'))
def cr_acct_alowedvalues(event):
    _ar = []
    
    try:
        _accts = org_client.list_accounts()
        for _act in _accts['Accounts']:
            ok_to_add =1

            if _act['Name'].find('Audit') > -1:
                ok_to_add = 0
            if _act['Name'].find('Log archive') > -1:
                ok_to_add = 0
                
            if ok_to_add == 1:
                _b = f"{_act['Name']}_{_act['Id']}" 
                _ar.append(_b)
            _ar.sort()
    except Exception as e:
        _ar.append('Error_gettingAccounts ' + str(e))
    return _ar
def update_sc_product(event, licinfo):
    rBUCKET = event['ResourceProperties']['DestBucket']
    Rprefix = event['ResourceProperties']['prefix'] 
    OUTPUT_KEY = f"{Rprefix}/config/scproduct-outagging.json"
    sc_mgtentitlementProduct = b_get_obj(rBUCKET, OUTPUT_KEY)
    sc_json = json.loads(sc_mgtentitlementProduct)
    b_putpriv(rBUCKET,OUTPUT_KEY, json.dumps(sc_json, indent=4),'text/json')
    sc_json_sc_s3loc = 'https://%s.s3.%s.amazonaws.com/%s' % (rBUCKET, os.environ['AWS_REGION'], OUTPUT_KEY)
    return sc_json_sc_s3loc

def cfnresponse(event, context, responseStatus, responseData, physicalResourceId=None, noEcho=False):
    responseBody = {}
    responseBody['Status'] = responseStatus
    responseBody['Reason'] = 'See the details in CloudWatch Log Stream: ' + \
        context.log_stream_name
    responseBody['PhysicalResourceId'] = physicalResourceId or context.log_stream_name
    responseBody['StackId'] = event['StackId']
    responseBody['RequestId'] = event['RequestId']
    responseBody['LogicalResourceId'] = event['LogicalResourceId']
    responseBody['NoEcho'] = noEcho
    responseBody['Data'] = responseData
    json_responseBody = json.dumps(responseBody)
    headers = {'content-type': '',
               'content-length': str(len(json_responseBody))}
    print("Response body:\n" + json_responseBody)
    try:
        response = http.request(
            'PUT', event['ResponseURL'], body=json_responseBody.encode('utf-8'), headers=headers)
        logger.debug('Status code: ' + response.reason)
    except Exception as e:
        logger.error(
            'cfnresponse(..) failed executing requests.put(..): ' + str(e))
def timeout(event, context):
    logging.error(
        'Execution is about to time out, sending failure response to CloudFormation')
    cfnresponse(event, context, 'FAILED')
def assume_role(account):

    assumedRoleObject = {}
    sts_client = boto3.client('sts')
    role_arn = 'arn:aws:iam::' + \
        account['AccountId'] + ':role/' + \
        account['adminRole']
    try:
        assumedRoleObject = sts_client.assume_role(
            RoleArn=role_arn,
            RoleSessionName="NewAccountRole"
        )
    except Exception as e:
        logger.warning(e)
        assumedRoleObject['status'] = str(e)

    return assumedRoleObject
def account_b_accept(targetAcctGrant, event):

    stack_desc = ''
    _rand = random.randint(10, 44200)
    acct_b = assume_role(targetAcctGrant)
    ACCESS_KEY = acct_b['Credentials']['AccessKeyId']
    SECRET_KEY = acct_b['Credentials']['SecretAccessKey']
    SESSION_TOKEN = acct_b['Credentials']['SessionToken']
    GrantArn = targetAcctGrant['GrantArn']

    ps_b_client = boto3.client(
        'license-manager',
        aws_access_key_id=ACCESS_KEY,
        aws_secret_access_key=SECRET_KEY,
        aws_session_token=SESSION_TOKEN,
    )
    #
    act_b_iam_client = boto3.client(
        'iam',
        aws_access_key_id=ACCESS_KEY,
        aws_secret_access_key=SECRET_KEY,
        aws_session_token=SESSION_TOKEN,
    )
    lookforroleacctb = look_for_mgtentitlement_role(
        act_b_iam_client, event)
    print(json.dumps(lookforroleacctb))
    if lookforroleacctb['found'] == "yes":
        sc_json_sc_key = f'content/mgtentitlement/mgtentitlement_role_setup_blank.json'
        sc_mgtentitlement_role = 'https://%s.s3.%s.amazonaws.com/%s' % (event['ResourceProperties']['HoldingBucket'], os.environ['AWS_REGION'], sc_json_sc_key)
    else:
        sc_json_sc_key = f'content/mgtentitlement/mgtentitlement_role_setup.json'
        sc_mgtentitlement_role = 'https://%s.s3.%s.amazonaws.com/%s' % (
            event['ResourceProperties']['HoldingBucket'], os.environ['AWS_REGION'], sc_json_sc_key)
        sc_mgtentitlement_role_surl = gen_surl(
            event['ResourceProperties']['HoldingBucket'], sc_json_sc_key)
        event['ResourceProperties']['taraccount'] = targetAcctGrant['AccountId']
        event['ResourceProperties']['StackName'] = f'mgtentitlementtRoleSetup{_rand}'
        event['ResourceProperties']['StackRegion'] = os.environ['AWS_REGION']
        event['ResourceProperties']['TemplateURL'] = sc_mgtentitlement_role_surl
        stack_desc = deploy_cloudformation(
            event, acct_b['Credentials'], "mgtentitlement setup")

    time.sleep(10)
    _grantret = ps_b_client.accept_grant(GrantArn=GrantArn)
    print('Accepted')

    time.sleep(10)
    _ngrantinfo = ps_b_client.get_grant(GrantArn=GrantArn)
    print('GetGrantAfterAccepted')

    SourceVersion = _ngrantinfo['Grant']['Version']
    ClientToken = f"ctoken{_rand}"
    _grantActivate = ps_b_client.create_grant_version(
        GrantArn=GrantArn, ClientToken=ClientToken, SourceVersion=SourceVersion, Status='ACTIVE')
    time.sleep(5)
    newGrantInfo = ps_b_client.get_grant(GrantArn=GrantArn)

    # build TargetAccount SC Env.
    sc_json_tar_sc_key = f'content/mgtentitlement/sc_mgtentitlement_setup.json'

    TarActSCtemplate = json.loads(b_get_obj(
        event['ResourceProperties']['HoldingBucket'], sc_json_tar_sc_key))
    TarActSCtemplate['Outputs'] = {}

    SCenduser = TarActSCtemplate['Parameters']['SCenduser']
    SCenduser['Default'] = f"role/{lookforroleacctb['portPrincipal']}"
    TarActSCtemplate['Parameters'] = {}
    TarActSCtemplate['Parameters']['SCenduser'] = SCenduser

    resource_portfolio = TarActSCtemplate['Resources']['SCPortfolio']
    resource_sc_product = TarActSCtemplate['Resources']['SCproductmEntitlements']
    resource_prod_associate = TarActSCtemplate[
        'Resources']['ProdAssociateSCproductmEntitlements']

    resource_SCPortPrincipal = TarActSCtemplate['Resources']['SCPortPrincipal']

    resource_portfolio['Properties']['DisplayName'] = 'AWS Marketplace Products'

    resource_sc_product['DependsOn'] = []
    prod_name = event['ResourceProperties']['License'].split(
        '_l-')[0]
    resource_sc_product['Properties']['Description'] = f"AWS Marketplace-{prod_name}"
    resource_sc_product['Properties']['Name'] = f"AWS Marketplace-{prod_name}"
    
    #fix ImageId for EC2
    ec2_template = json.loads(b_get_obj(event['ResourceProperties']['HoldingBucket'], 'content/mgtentitlement/sc_mgtentitlement_ec2_product.json'))
    
    ec2_template['Parameters']['ImageId']['Default'] = event['ResourceProperties']['ImageId']
    
    ec2_template_key= f'content/mgtentitlement/sc_mgtentitlement_ec2_product{_rand}.json'
    b_putpriv(event['ResourceProperties']['HoldingBucket'],ec2_template_key,json.dumps(ec2_template, indent=2),'text/json')
    

    resource_sc_product['Properties']['ProvisioningArtifactParameters'][0]['Info']['LoadTemplateFromURL'] = gen_surl(
        event['ResourceProperties']['HoldingBucket'], ec2_template_key)

    TarActSCtemplate['Resources'] = {}

    TarActSCtemplate['Resources']['SCPortfolio'] = resource_portfolio
    TarActSCtemplate['Resources']['SCproductmEntitlements'] = resource_sc_product
    TarActSCtemplate['Resources']['ProdAssociateSCproductmEntitlements'] = resource_prod_associate
    if lookforroleacctb['portPrincipal'] != '':
        TarActSCtemplate['Resources']['SCPortPrincipal'] = resource_SCPortPrincipal
        
    TarActSCtemplate['Description'] = f"AWS Marketplace-MgtEntitlements-{prod_name}"

    tarsckey = f"content/mgtentitlement/sc_mgtentitlement_sc_env{_rand}_{targetAcctGrant['AccountId']}.json"
    b_putpriv(event['ResourceProperties']['HoldingBucket'],
              tarsckey, json.dumps(TarActSCtemplate, indent=2),'text/json')

    sc_mgtentitlement_role_surl = gen_surl(
        event['ResourceProperties']['HoldingBucket'], tarsckey)
    
    cleanprod_name = prod_name.replace(' ','')
    cleanprod_name = cleanprod_name.replace('(','')
    cleanprod_name = cleanprod_name.replace(')','')
    

    event['ResourceProperties']['taraccount'] = targetAcctGrant['AccountId']
    event['ResourceProperties']['StackName'] = f'mgtentitle-{cleanprod_name}-{_rand}'
    event['ResourceProperties']['StackRegion'] = os.environ['AWS_REGION']
    event['ResourceProperties']['TemplateURL'] = sc_mgtentitlement_role_surl
    stack_desc = deploy_cloudformation(
        event, acct_b['Credentials'], "mgtentitlementTarget setup")

    return newGrantInfo
def deploy_cloudformation(event, acct_b, application):

    logger.debug("Deploying Resources")
    stack_name = event['ResourceProperties']['StackName']
    stack_region = event['ResourceProperties']['StackRegion']
    TemplateURL = event['ResourceProperties']['TemplateURL']
    taraccount = event['ResourceProperties']['taraccount']
    datestamp = time.strftime("%d/%m/%Y")

    client = boto3.client('cloudformation',
                          aws_access_key_id=acct_b['AccessKeyId'],
                          aws_secret_access_key=acct_b['SecretAccessKey'],
                          aws_session_token=acct_b['SessionToken'],
                          region_name=stack_region)

    logger.info("Creating stack " +
                stack_name + " in " + taraccount)
    logger.info(
        "Creating stack TemplateURL[" + TemplateURL + "]")
    creating_stack = True
    while creating_stack is True:
        try:
            creating_stack = False
            create_stack_response = client.create_stack(
                StackName=stack_name,
                TemplateURL=TemplateURL,
                Parameters=[],
                NotificationARNs=[],
                Capabilities=[
                    'CAPABILITY_NAMED_IAM'
                ],
                OnFailure='ROLLBACK',
                Tags=[
                    {
                        'Key': 'ManagedResource',
                        'Value': 'True'
                    },
                    {
                        'Key': 'DeployDate',
                        'Value': datestamp
                    }
                ]
            )

        except ClientError as e:
            to_raise = ['AlreadyExistsException', 'LimitExceededException',
                        'InsufficientCapabilitiesException']
            logger.error(e.response)
            if e.response['Error']['Code'] in to_raise:
                client.delete_stack(StackName=stack_name)
                logger.error(e)
                raise
            creating_stack = True
            logger.warning(e)
            logger.warning("Retrying...")
            time.sleep(10)
        except Exception as e:
            logger.error(e)

        stack_building = True
        logger.info("Stack creation in process...")
        # logger.info(create_stack_response)
        while stack_building is True:
            event_list = client.describe_stack_events(
                StackName=stack_name).get("StackEvents")
            stack_event = event_list[0]

            if (stack_event.get('ResourceType') == 'AWS::CloudFormation::Stack' and
                    stack_event.get('ResourceStatus') == 'CREATE_COMPLETE'):
                stack_building = False
                logger.info("Stack construction complete.")
            elif (stack_event.get('ResourceType') == 'AWS::CloudFormation::Stack' and
                  stack_event.get('ResourceStatus') == 'ROLLBACK_COMPLETE'):
                client.delete_stack(StackName=stack_name)
                stack_building = False
                logger.error("Stack construction failed.")
                sys.exit(1)
            else:
                logger.info(stack_event)
                logger.info("Stack building . . .")
                time.sleep(10)
        stack = client.describe_stacks(StackName=stack_name)
        return stack
def sc_create_product(event):
    rBUCKET = event['ResourceProperties']['DestBucket']
    Rprefix = event['ResourceProperties']['prefix'] 
    OUTPUT_KEY = f"{Rprefix}/config/scproduct-outagging.json"
    sc_mgtentitlementProduct = b_get_obj(rBUCKET, OUTPUT_KEY)
    sc_json = json.loads(sc_mgtentitlementProduct)
    b_putpriv(rBUCKET,OUTPUT_KEY, json.dumps(sc_json, indent=4),'text/json')
    sc_json_sc_s3loc = 'https://%s.s3.%s.amazonaws.com/%s' % (rBUCKET, os.environ['AWS_REGION'], OUTPUT_KEY)
    sc_client.create_product(
    AcceptLanguage='en',
    Name='SCUpdateOUTags',
    Owner='AWS',
    Description='Update the tags on CT OU for automation',
    Distributor='MP',
    SupportDescription='Update the tags on CT OU for automation',
    SupportEmail='string',
    SupportUrl='string',
    ProductType='CLOUD_FORMATION_TEMPLATE'|'MARKETPLACE',
    Tags=[
        {
            'Key': 'string',
            'Value': 'string'
        },
    ],
    ProvisioningArtifactParameters={
        'Name': 'string',
        'Description': 'string',
        'Info': {
            'string': 'string'
        },
        'Type': 'CLOUD_FORMATION_TEMPLATE'|'MARKETPLACE_AMI'|'MARKETPLACE_CAR',
        'DisableTemplateValidation': True|False
    },
    IdempotencyToken='string')
    
    return sc_json_sc_s3loc        
def sc_deactivat_ver(_newversion, _prodinfo):
    for _product in _prodinfo:
        if _newversion != _product['Name']:
            response = sc_client.update_provisioning_artifact(AcceptLanguage='en', ProductId=_product[
                                                              'ProductId'],    ProvisioningArtifactId=_product['ProvisioningArtifactId'], Active=False, Guidance='DEPRECATED')
    return 0
def sc_create_pa(ProductId, version, description, template):
    _rand = random.randint(323, 24200)
    IdempotencyToken = "tok%s" % _rand
    rep = sc_client.create_provisioning_artifact(AcceptLanguage='en', ProductId=ProductId, Parameters={
        'Name': version,
        'Description': description,
        'Info': {
            "LoadTemplateFromURL": template
        },
        'Type': 'CLOUD_FORMATION_TEMPLATE',
        'DisableTemplateValidation': True
    },
        IdempotencyToken=IdempotencyToken
    )

    return rep
def sc_describe_product(name):
    rep = {}
    try:
        rep = sc_client.describe_product_as_admin(
            AcceptLanguage='en', Name=name)
    except Exception as e:
        e = str(e)
        print(e)
        if e.find('ResourceNotFoundException') > -1:
            print(name + ' not found')
            return 'not found'
    ProductId = rep['ProductViewDetail']['ProductViewSummary']['ProductId']
    # print(rep)
    # print(rep['ProvisioningArtifactSummaries'])
    _ret = []
    for _prodversion in rep['ProvisioningArtifactSummaries']:
        _version = {'ProductId': ProductId, 'ProvisioningArtifactId': _prodversion[
            'Id'], 'Name': _prodversion['Name'], 'Description': _prodversion['Description']}
        _ret.append(_version)
    return _ret
def sc_updateProduct(_sc_productname, template):
    _prodinfo = sc_describe_product(_sc_productname)
    _versions = len(_prodinfo) + 1
    ProductId = _prodinfo[0]['ProductId']
    version = 'Latest %s.0' % _versions
    description = 'Decription %s' % version
    pa_rep = sc_create_pa(
        ProductId, version, description, template)
    _ret = {'ProductId': ProductId, 'version': version,
            'ProvisioningArtifactId': pa_rep['ProvisioningArtifactDetail']['Id']}
    # Deactivate old version
    _prodinfo = sc_describe_product(_sc_productname)
    sc_deactivat_ver(version, _prodinfo)
    return _ret
def ListAccounts(orgname):
    _ar = []
    try:
        _ret = org_client.list_roots()
        _id = _ret['Roots'][0]['Id']
        _ret2 = org_client.list_organizational_units_for_parent(    ParentId=_id) 
        for _o in _ret2['OrganizationalUnits']:
            if _o['Name'] == orgname :
                ParentId = _o['Id']
        
        _accts = org_client.list_accounts_for_parent(ParentId=ParentId)
        for _act in _accts['Accounts']:
            _b = f"{_act['Name']}_{_act['Id']}_{_act['Status']}"
            _ar.append(_b)
            _ar.sort()
    except Exception as e:
        _ar.append('Error_gettingAccounts ' + str(e))
    return _ar

def generate_report (event):
    _ret={}
    localtime = time.asctime( time.localtime(time.time()) ).replace("  "," ").replace(" ","-").replace(":","-")
    _reportdata = get_ou_tags(event)
    #return _ret
    
    style = """ <style type="text/css">
    #customers {
      font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
      font-size: 18px;
      border-collapse: collapse
    }
    #customers td, #customers th {
      border: 1px solid #ddd;
      padding: 8px;
      text-align: left;
    
    }
    #customers tr:nth-child(even){background-color: #f2f2f2;}
    
    #customers tr:hover {background-color: #ddd;}
    
    #customers th {
      padding-top: 12px;
      padding-bottom: 12px;
      font-family: "Trebuchet MS", Arial, Helvetica, sans-serif;
      font-size: 18px;
      text-align: left;
      background-color: white;
      color: black;
    }</style>"""
      
      

    rows = ""
    for lorg in _reportdata:
        rOrgName = lorg['Name']
        rows += f"<tr> <th colspan=4>{rOrgName}</th></tr>"
        for _tags in lorg['Tags']:
            rows += f"<tr><td>{_tags['Key']}</td><td>{_tags['Value']}</td></tr>"
        
    
    table = f"OrganizationalUnit Tags Report {localtime}<br><table id='customers'>{rows}<table>"
    
    html = f"<html lang='en'><head><title></title>{style}</head><body>{table}</body></html>"
    #Reporting
    rBUCKET = event['ResourceProperties']['DestBucket']
    Rprefix = event['ResourceProperties']['prefix'] 
    region = os.environ['AWS_REGION']
    OUTPUT_KEY = f"{Rprefix}/report/organizatoion-tag_reports.html"
    b_putpriv(rBUCKET, OUTPUT_KEY, html,'text/html')
    _ret = gen_surl(rBUCKET, OUTPUT_KEY)

    return _ret
def get_ou_tags(event):
    _ret = org_client.list_roots()
    _id = _ret['Roots'][0]['Id']
    _r_arr=[]
    _ret2 = org_client.list_organizational_units_for_parent(    ParentId=_id) 
    for _o in _ret2['OrganizationalUnits']:
        #print(_o)
        if _o['Name'].find('Core') > -1 :
            mess='not the core'
        else:
          
            _ouinfo = describeOu(_o['Id'],event)
            _r_arr.append(_ouinfo)
    return _r_arr
def tag_the_ou(event):
    _ret = org_client.list_roots()
    _id = _ret['Roots'][0]['Id']
    _r_arr=[]
    _ret2 = org_client.list_organizational_units_for_parent(    ParentId=_id) 
    for _o in _ret2['OrganizationalUnits']:
        #print(_o)
        if _o['Name'].find('Core') > -1 :
            mess='not the core'
        else:
          
            _ouinfo = describeOu(_o['Id'],event)
            _r_arr.append(_ouinfo)
    
    bucket = event['ResourceProperties']['DestBucket']    
    jsonplaceholder = {
          "AWSTemplateFormatVersion": "2010-09-09",
          "Description": "CT OU-tags postaction placeHolder",
          "Resources": {
            "WaitHandle": {
              "Type": "AWS::CloudFormation::WaitConditionHandle"}}}
  

    jsonout = json.dumps(jsonplaceholder,indent=3)
   
    _crtagsarray=[]
    for _ou in _r_arr:
        _Tags = _ou['outagging']
        _crtagevnt = {'ResourceId':_ou['Id'],'Tags':_Tags}
        _crtagsarray.append(_crtagevnt)
        _crtags_res = tag_org_create(_crtagevnt)
        #create s3 file
        for _stag in _Tags:
            s3key = _stag['Value'].split('.com/')[1]
            b_putpriv(bucket, s3key, jsonout,'text/json')
            
            
        
    return(_crtagsarray)

def describeOu(OrganizationalUnitId,event):
    _res = org_client.describe_organizational_unit(OrganizationalUnitId=OrganizationalUnitId)['OrganizationalUnit']
    _res['Tags'] =org_client.list_tags_for_resource( ResourceId=OrganizationalUnitId)['Tags']
    _tag_ar =[]
     

    _actions  = event['ResourceProperties']['life_cycle_actions']
    
    bucket = event['ResourceProperties']['DestBucket']
    prefix = event['ResourceProperties']['prefix']
 
    s3key = f"https://{bucket}.s3.amazonaws.com/{prefix}/config/"
    
 
 
    for a in _actions:
        av = f"{s3key}{_res['Name']}-{a}-postaction.json"
        tag = {'Key':a,'Value':av}
        _tag_ar.append(tag)
    _res['outagging'] = _tag_ar
 
    return _res
def create_sc_product_cft(event):
    _ret={}
    localtime = time.asctime( time.localtime(time.time()) ).replace("  "," ").replace(" ","-").replace(":","-")
    _reportdata = get_ou_tags(event)
    _par= {}
 
    _prop ={}
    _outag_array =[]
    for lorg in _reportdata:
        for _tags in lorg['Tags']:
            _pname = lorg['Name'].upper()+_tags['Key']
            _par[_pname] = {'Description':'OrganizationalUnit '+lorg['Name']+' TAG '+_tags['Key'],'Type':'String','Default':_tags['Value']}
            #_prop[lorg['Name']+_tags['Key']] = {'Ref':lorg['Name']+_tags['Key']}
            _propa = {'orgname':lorg['Name'],'tagname':_tags['Key'],'tagvalue':{'Ref':_pname}}
            _outag_array.append(_propa)
            
    _par['00ProductActions'] = {'Description':'Actions to do','Type':'String','Default':'UpdateTags','AllowedValues':['UpdateTags','GetReport']}
    _prop['ServiceToken'] = event['ResourceProperties']['ServiceToken']
    _prop['DestBucket']   = event['ResourceProperties']['DestBucket']
    _prop['prefix']       = event['ResourceProperties']['prefix']
    _prop['action']       = {'Ref':'00ProductActions'}
    _prop['scproductname'] = event['ResourceProperties']['scproductname'] 
    _prop['outags']       = _outag_array
    _prop['life_cycle_actions'] = ['CreateManagedAccount','UpdateManagedAccount','RegisterOrganizationalUnit']
    _prop['00ProductActions'] = {'Ref':'00ProductActions'}
    
    _report = generate_report (event)
    
    _template = {
           'AWSTemplateFormatVersion': '2010-09-09',
           'Description': 'Service Catalog CT OU Tag automation (fdp-1r56d8b0r)',
           'Parameters':_par,
           'Outputs':{'OuTagReport': {
           'Description': "Report of OU and tags",
           'Value': _report}},
           'Resources':{'updateit':{'Properties':_prop,'Type':'Custom::updateit'}}}
           
    
    #s3 cft
    rBUCKET = event['ResourceProperties']['DestBucket']
    Rprefix = event['ResourceProperties']['prefix'] 
    OUTPUT_KEY = f"{Rprefix}/config/sc_ct_tag_automation.json"
    b_putpriv(rBUCKET, OUTPUT_KEY, json.dumps(_template,indent =4),'text/json')
    
    _ret =   f"https://{rBUCKET}.s3.amazonaws.com/{Rprefix}/config/sc_ct_tag_automation.json"

    return _ret 
 

def get_ouid(ouname):
    _ret = org_client.list_roots()
    _id = _ret['Roots'][0]['Id']
    _ret2 = org_client.list_organizational_units_for_parent(    ParentId=_id) 
    for _o in _ret2['OrganizationalUnits']:
        if _o['Name'].find(ouname) > -1 :
            _retouid = _o['Id']
            
    return _retouid
    
def tag_org_create(event):
    _res = org_client.tag_resource(ResourceId=event['ResourceId'],Tags=event['Tags'])
    return _res
    
def sc_update_ou_tags(event):
    oulist = event['ResourceProperties']['outags']
    for ou in oulist:
        _ouid = get_ouid(ou['orgname'])
        Tags = [{ 'Key': ou['tagname'], 'Value': ou['tagvalue']}]       
        iktevent = {'ResourceId':_ouid,'Tags':Tags}
        tag_org_create(iktevent)
    
        
    return iktevent    
        
        
def lambda_handler(event, context):
    print(json.dumps(event))
    
    timer = threading.Timer((context.get_remaining_time_in_millis()
                             / 1000.00) - 0.5, timeout, args=[event, context])
    timer.start()
    status = 'SUCCESS'
    _ret = {}
    _ret['report']='none'
    _ret['message']='none'
    try:
        if event['RequestType'] == 'Create':
            if event['ResourceProperties']['action'] == "UpdateTags":
                sc_update_ou_tags(event)
                _ret['report'] =  generate_report (event)
                _template = create_sc_product_cft(event)
                
                sc_updateProduct(event['ResourceProperties']['scproductname'], _template)
            if event['ResourceProperties']['action'] == "GetReport":
                _ret['report'] =  generate_report (event)
                
            
            if event['ResourceProperties']['action'] == "create_setup":
                tag_the_ou(event)
                _ret['report']=  generate_report (event)
                _template = create_sc_product_cft(event)
                _ret['template'] = _template

        if event['RequestType'] == 'Delete':
            _ret['message'] = f"My action will be to Delete  "
    except Exception as e:
        print(e)
        logging.error('Exception: %s' % e, exc_info=True)
        status = FAILED
    finally:
        timer.cancel()
        cfnresponse(event, context, status, _ret)
        return _ret
